#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "token4xi.py">
#<abstract4xi abstract = "provides Token4Xi class"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Token4Xi' ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import weakref
import threading
import array
import queue
from traceback import format_exc
import copyreg
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:
    from multiprocessing import managers
except:
    print("token4xi.py *** failed in from multiprocessing import managers ***") 
try:
    from multiprocessing.managers import Token
except:
    print("token4xi.py *** failed in from multiprocessing.managers import Token ***")         
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



#
# =================================================================================================
#<class4xi class = "Token4Xi" base = "object" child = "None" synopsis = "the type to uniquely indentify a shared object" usage = "
#     managers.py 
#         token = Token(typeid, self.address, rident)
#     basemanager4xi.py
#         return Token4Xi(typeid, self._address, id), exposed
#     server4xi.py:
#         token2xi = Token4Xi(typeid2xi, self.address, rident2xi)
#     syncmanager4xi.py:
#         return Token4Xi(typeid, self._address, id), exposed"
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#>
# =================================================================================================
#
class Token4Xi(object):
    '''
    the type to uniquely indentify a shared object
    '''
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    __slots__ = ('typeid', 'address', 'id')
    #"
    #/>
      
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Token4Xi" usage = "initializes Token4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self, typeid, address, id):
        '''
        Token4Xi method __init__ initializes Token4Xi
        '''
        class2print = "Token4Xi"
        method2print = "__init__"

        message2print = "{started" + "; init-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                                
        message2print = "{borning" + "; token2xi-of-Token4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        message2print = "{inheriting" + "; object-inheriting-by-token2xi-of-Token4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{sharing" + "; slots-sharing-by-token2xi-of-Token4Xi: " + str(Token4Xi.__slots__)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                                                
        message2print = "{passed" + "; typeid-passed-to-init-of-Token4Xi: " + str(typeid) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                
        if address is None:
        
            message2print = "{yielded" + "; address-yielded-to-init-of-Token4Xi: " + str(address) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                  
                        
        message2print = "{passed" + "; id-passed-to-init-of-Token4Xi: " + str(id) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                         
                      
        
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------  
        (self.typeid, self.address, self.id) = (typeid, address, id)
        
        message2print = "{set" + "; typeid-of-token2xi-set-by-init-of-Token4Xi to: " + str(self.typeid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{set" + "; address-of-token2xi-set-by-init-of-Token4Xi to: " + str(self.address)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{set" + "; id-of-token2xi-set-by-init-of-Token4Xi to: " + str(self.id)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                                
                     

        # -----------------------------------------------------------------------------------------    
        # 
        # ----------------------------------------------------------------------------------------- 
        message2print = "{activated" + "; token2xi-of-Token4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{inherited" + "; object-inherited-by-token2xi-of-Token4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{shared" + "; slots-shared-by-token2xi-of-Token4Xi: " + str(Token4Xi.__slots__)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                          
        message2print = "{returning" + "; init-of-Token4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                                

    #</methodize4xi>
    
             
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getstate-of-Token4Xi" usage = "returns state with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>    
    # ---------------------------------------------------------------------------------------------
    def __getstate__(self):
        '''
        Token4Xi method __getstate__ returns state with (self) 
        '''        
        class2print = "Token4Xi"
        method2print = "__getstate__"

        message2print = "{started" + "; getstate-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------  
        message2print = "{returning" + "; typeid-address-id-of-token2xi-returning-by-getstate-of-Token4Xi: " + str((self.typeid, self.address, self.id)) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                         
        
        return (self.typeid, self.address, self.id)
    #</methodize4xi>
    
         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "setstate-of-Token4Xi" usage = "sets state with (self, state)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __setstate__(self, state):
        '''
        Token4Xi method __setstate__ sets state with (self, state)
        '''
        class2print = "Token4Xi"
        method2print = "__setstate__"

        message2print = "{started" + "; setstate-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{passed" + "; state-passed-to-setstate-of-Token4Xi: " + str(state) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------  
       
        
        (self.typeid, self.address, self.id) = state

        
        message2print = "{set" + "; state-of-token2xi-set-by-setstate-of-Token4Xi to: " + str((self.typeid, self.address, self.id)) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
                              
         
        # -----------------------------------------------------------------------------------------    
        # 
        # ----------------------------------------------------------------------------------------- 
        message2print = "{returning" + "; setstate-of-Token4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                             
    #</methodize4xi>
    
          
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-Token4Xi" usage = "returns repr with (self)">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
    # ---------------------------------------------------------------------------------------------
    def __repr__(self):
        '''
        Token4Xi method __repr__ returns repr with (self)
        '''    
        class2print = "Token4Xi"
        method2print = "__repr__"
 
        message2print = "{started" + "; repr-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        # -----------------------------------------------------------------------------------------    
        # 
        # -----------------------------------------------------------------------------------------  
        message2print = "{returning" + "; typeid-address-id-of-token2xi-returning-by-repr-of-Token4Xi: " + str((self.typeid, self.address, self.id)) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        
        return 'Token4Xi(typeid=%r, address=%r, id=%r)' % \
               (self.typeid, self.address, self.id)
    #</methodize4xi>
    
     
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Token4Xi" usage = "senses Token4Xi class objects">
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Token4Xi class objects
        '''

        
        class2print = 'Token4Xi'
        method2print = 'sense'
        
 
        message2print = "{started" + "; sense-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; Token4Xi-sensing-by-sense-of-Token4Xi: " + str(Token4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Token4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['slots-of-Token4Xi'] =  Token4Xi.__slots__
            kb2xi['state-of-token2xi'] =  (self.typeid, self.address, self.id)
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-Token4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
           
            
        message2print = "{sensed" + "; Token4Xi-sensed-by-sense-of-Token4Xi: " + str(Token4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Token4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                            
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
     
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Token4Xi" usage = "reasons Token4Xi class objects">
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Token4Xi class objects
        '''
 
        
        class2print = 'Token4Xi'
        method2print = 'reason'

 
        message2print = "{started" + "; reason-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Token4Xi-reasoning-by-reason-of-Token4Xi: " + str(Token4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)

        message2print = "{got" + "; kb4xi-got-by-reason-of-Token4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        message2print = "{reasoned" + "; Token4Xi-reasoned-by-reason-of-Token4Xi: " + str(Token4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Token4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
     
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Token4Xi" usage = "aces Token4Xi class objects">
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Token4Xi class objects 
        '''

        class2print = 'Token4Xi'
        method2print = 'ace'
        
 
        message2print = "{started" + "; ace-of-Token4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Token4Xi-acing-by-ace-of-Token4Xi: " + str(Token4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Token4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Token4Xi-aced-by-ace-of-Token4Xi: " + str(Token4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Token4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>
#<end4xi end = "

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-none4xi.xml
#   reason-none4xi.xml
#   ace-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

# -------------------------------------------------------------------------------------------------
# end of token4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
